<?php
/**
 * DefaultApi
 * PHP version 5
 *
 * @category Class
 * @package  UPS\DangerousGoods
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Dangerous Goods Utility
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.50
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace UPS\DangerousGoods\Request;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use UPS\DangerousGoods\ApiException;
use UPS\DangerousGoods\Configuration;
use UPS\DangerousGoods\HeaderSelector;
use UPS\DangerousGoods\ObjectSerializer;

/**
 * DefaultApi Class Doc Comment
 *
 * @category Class
 * @package  UPS\DangerousGoods
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class DefaultApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation acceptanceAuditPreCheck
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version API version  Valid values: - v2 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper
     */
    public function acceptanceAuditPreCheck($body, $trans_id, $transaction_src, $version)
    {
        list($response) = $this->acceptanceAuditPreCheckWithHttpInfo($body, $trans_id, $transaction_src, $version);
        return $response;
    }

    /**
     * Operation acceptanceAuditPreCheckWithHttpInfo
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version API version  Valid values: - v2 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper, HTTP status code, HTTP response headers (array of strings)
     */
    public function acceptanceAuditPreCheckWithHttpInfo($body, $trans_id, $transaction_src, $version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper';
        $request = $this->acceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $version);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 429:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation acceptanceAuditPreCheckAsync
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version API version  Valid values: - v2 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function acceptanceAuditPreCheckAsync($body, $trans_id, $transaction_src, $version)
    {
        return $this->acceptanceAuditPreCheckAsyncWithHttpInfo($body, $trans_id, $transaction_src, $version)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation acceptanceAuditPreCheckAsyncWithHttpInfo
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version API version  Valid values: - v2 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function acceptanceAuditPreCheckAsyncWithHttpInfo($body, $trans_id, $transaction_src, $version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper';
        $request = $this->acceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $version);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'acceptanceAuditPreCheck'
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version API version  Valid values: - v2 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function acceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $version)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling acceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'trans_id' is set
        if ($trans_id === null || (is_array($trans_id) && count($trans_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $trans_id when calling acceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'transaction_src' is set
        if ($transaction_src === null || (is_array($transaction_src) && count($transaction_src) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $transaction_src when calling acceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'version' is set
        if ($version === null || (is_array($version) && count($version) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $version when calling acceptanceAuditPreCheck'
            );
        }

        $resourcePath = '/dangerousgoods/{version}/acceptanceauditprecheck';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($trans_id !== null) {
            $headerParams['transId'] = ObjectSerializer::toHeaderValue($trans_id);
        }
        // header params
        if ($transaction_src !== null) {
            $headerParams['transactionSrc'] = ObjectSerializer::toHeaderValue($transaction_src);
        }

        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                '{' . 'version' . '}',
                ObjectSerializer::toPathValue($version),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation chemicalReferenceData
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version Version of the API.  Valid values: - v2403 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper
     */
    public function chemicalReferenceData($body, $trans_id, $transaction_src, $version)
    {
        list($response) = $this->chemicalReferenceDataWithHttpInfo($body, $trans_id, $transaction_src, $version);
        return $response;
    }

    /**
     * Operation chemicalReferenceDataWithHttpInfo
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version Version of the API.  Valid values: - v2403 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper, HTTP status code, HTTP response headers (array of strings)
     */
    public function chemicalReferenceDataWithHttpInfo($body, $trans_id, $transaction_src, $version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper';
        $request = $this->chemicalReferenceDataRequest($body, $trans_id, $transaction_src, $version);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 429:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation chemicalReferenceDataAsync
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version Version of the API.  Valid values: - v2403 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function chemicalReferenceDataAsync($body, $trans_id, $transaction_src, $version)
    {
        return $this->chemicalReferenceDataAsyncWithHttpInfo($body, $trans_id, $transaction_src, $version)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation chemicalReferenceDataAsyncWithHttpInfo
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version Version of the API.  Valid values: - v2403 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function chemicalReferenceDataAsyncWithHttpInfo($body, $trans_id, $transaction_src, $version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper';
        $request = $this->chemicalReferenceDataRequest($body, $trans_id, $transaction_src, $version);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'chemicalReferenceData'
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $version Version of the API.  Valid values: - v2403 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function chemicalReferenceDataRequest($body, $trans_id, $transaction_src, $version)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling chemicalReferenceData'
            );
        }
        // verify the required parameter 'trans_id' is set
        if ($trans_id === null || (is_array($trans_id) && count($trans_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $trans_id when calling chemicalReferenceData'
            );
        }
        // verify the required parameter 'transaction_src' is set
        if ($transaction_src === null || (is_array($transaction_src) && count($transaction_src) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $transaction_src when calling chemicalReferenceData'
            );
        }
        // verify the required parameter 'version' is set
        if ($version === null || (is_array($version) && count($version) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $version when calling chemicalReferenceData'
            );
        }

        $resourcePath = '/dangerousgoods/{version}/chemicalreferencedata';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($trans_id !== null) {
            $headerParams['transId'] = ObjectSerializer::toHeaderValue($trans_id);
        }
        // header params
        if ($transaction_src !== null) {
            $headerParams['transactionSrc'] = ObjectSerializer::toHeaderValue($transaction_src);
        }

        // path params
        if ($version !== null) {
            $resourcePath = str_replace(
                '{' . 'version' . '}',
                ObjectSerializer::toPathValue($version),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deprecatedAcceptanceAuditPreCheck
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version API version  Valid values: - v1 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper
     */
    public function deprecatedAcceptanceAuditPreCheck($body, $trans_id, $transaction_src, $deprecated_version)
    {
        list($response) = $this->deprecatedAcceptanceAuditPreCheckWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version);
        return $response;
    }

    /**
     * Operation deprecatedAcceptanceAuditPreCheckWithHttpInfo
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version API version  Valid values: - v1 (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper, HTTP status code, HTTP response headers (array of strings)
     */
    public function deprecatedAcceptanceAuditPreCheckWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper';
        $request = $this->deprecatedAcceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $deprecated_version);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 429:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deprecatedAcceptanceAuditPreCheckAsync
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version API version  Valid values: - v1 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deprecatedAcceptanceAuditPreCheckAsync($body, $trans_id, $transaction_src, $deprecated_version)
    {
        return $this->deprecatedAcceptanceAuditPreCheckAsyncWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deprecatedAcceptanceAuditPreCheckAsyncWithHttpInfo
     *
     * Acceptance Audit Pre-check
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version API version  Valid values: - v1 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deprecatedAcceptanceAuditPreCheckAsyncWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCResponseWrapper';
        $request = $this->deprecatedAcceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $deprecated_version);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deprecatedAcceptanceAuditPreCheck'
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYAPCRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version API version  Valid values: - v1 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deprecatedAcceptanceAuditPreCheckRequest($body, $trans_id, $transaction_src, $deprecated_version)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling deprecatedAcceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'trans_id' is set
        if ($trans_id === null || (is_array($trans_id) && count($trans_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $trans_id when calling deprecatedAcceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'transaction_src' is set
        if ($transaction_src === null || (is_array($transaction_src) && count($transaction_src) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $transaction_src when calling deprecatedAcceptanceAuditPreCheck'
            );
        }
        // verify the required parameter 'deprecated_version' is set
        if ($deprecated_version === null || (is_array($deprecated_version) && count($deprecated_version) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $deprecated_version when calling deprecatedAcceptanceAuditPreCheck'
            );
        }

        $resourcePath = '/dangerousgoods/{deprecatedVersion}/acceptanceauditprecheck';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($trans_id !== null) {
            $headerParams['transId'] = ObjectSerializer::toHeaderValue($trans_id);
        }
        // header params
        if ($transaction_src !== null) {
            $headerParams['transactionSrc'] = ObjectSerializer::toHeaderValue($transaction_src);
        }

        // path params
        if ($deprecated_version !== null) {
            $resourcePath = str_replace(
                '{' . 'deprecatedVersion' . '}',
                ObjectSerializer::toPathValue($deprecated_version),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deprecatedChemicalReferenceData
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version Version of the API.  Valid values: - v1 - v1801. (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper
     */
    public function deprecatedChemicalReferenceData($body, $trans_id, $transaction_src, $deprecated_version)
    {
        list($response) = $this->deprecatedChemicalReferenceDataWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version);
        return $response;
    }

    /**
     * Operation deprecatedChemicalReferenceDataWithHttpInfo
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version Version of the API.  Valid values: - v1 - v1801. (required)
     *
     * @throws \UPS\DangerousGoods\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper, HTTP status code, HTTP response headers (array of strings)
     */
    public function deprecatedChemicalReferenceDataWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper';
        $request = $this->deprecatedChemicalReferenceDataRequest($body, $trans_id, $transaction_src, $deprecated_version);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 403:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 429:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\UPS\DangerousGoods\DangerousGoods\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deprecatedChemicalReferenceDataAsync
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version Version of the API.  Valid values: - v1 - v1801. (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deprecatedChemicalReferenceDataAsync($body, $trans_id, $transaction_src, $deprecated_version)
    {
        return $this->deprecatedChemicalReferenceDataAsyncWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deprecatedChemicalReferenceDataAsyncWithHttpInfo
     *
     * Chemical Reference Data
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version Version of the API.  Valid values: - v1 - v1801. (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deprecatedChemicalReferenceDataAsyncWithHttpInfo($body, $trans_id, $transaction_src, $deprecated_version)
    {
        $returnType = '\UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYResponseWrapper';
        $request = $this->deprecatedChemicalReferenceDataRequest($body, $trans_id, $transaction_src, $deprecated_version);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deprecatedChemicalReferenceData'
     *
     * @param  \UPS\DangerousGoods\DangerousGoods\DANGEROUSGOODSUTILITYRequestWrapper $body Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click &quot;Authorize&quot; and enter your application credentials, then populate the required parameters above and click &quot;Try it out&quot;. (required)
     * @param  string $trans_id An identifier unique to the request. Length 32 (required)
     * @param  string $transaction_src An identifier of the client/source application that is making the request.Length 512 (required)
     * @param  string $deprecated_version Version of the API.  Valid values: - v1 - v1801. (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deprecatedChemicalReferenceDataRequest($body, $trans_id, $transaction_src, $deprecated_version)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling deprecatedChemicalReferenceData'
            );
        }
        // verify the required parameter 'trans_id' is set
        if ($trans_id === null || (is_array($trans_id) && count($trans_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $trans_id when calling deprecatedChemicalReferenceData'
            );
        }
        // verify the required parameter 'transaction_src' is set
        if ($transaction_src === null || (is_array($transaction_src) && count($transaction_src) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $transaction_src when calling deprecatedChemicalReferenceData'
            );
        }
        // verify the required parameter 'deprecated_version' is set
        if ($deprecated_version === null || (is_array($deprecated_version) && count($deprecated_version) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $deprecated_version when calling deprecatedChemicalReferenceData'
            );
        }

        $resourcePath = '/dangerousgoods/{deprecatedVersion}/chemicalreferencedata';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($trans_id !== null) {
            $headerParams['transId'] = ObjectSerializer::toHeaderValue($trans_id);
        }
        // header params
        if ($transaction_src !== null) {
            $headerParams['transactionSrc'] = ObjectSerializer::toHeaderValue($transaction_src);
        }

        // path params
        if ($deprecated_version !== null) {
            $resourcePath = str_replace(
                '{' . 'deprecatedVersion' . '}',
                ObjectSerializer::toPathValue($deprecated_version),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\Query::build($formParams);
            }
        }

        // this endpoint requires OAuth (access token)
        if ($this->config->getAccessToken() !== null) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\Query::build($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
