# PreNotification
No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 
- Package version: 1.0.8
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/abantecart/ups-pre-notification.git"
    }
  ],
  "require": {
    "abantecart/ups-pre-notification": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/PreNotification/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: oauth2
$config = UPS\PreNotification\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new UPS\PreNotification\Request\DefaultApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \UPS\PreNotification\PreNotification\PRENOTIFICATIONRequestWrapper(); // \UPS\PreNotification\PreNotification\PRENOTIFICATIONRequestWrapper | Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click "Authorize" and enter your application credentials, then populate the required parameters above and click "Try it out".
$version = "version_example"; // string | Version of API.  Valid values: - v2
$trans_id = "trans_id_example"; // string | An identifier unique to the request. Length 32
$transaction_src = "testing"; // string | An identifier of the client/source application that is making the request.Length 512

try {
    $result = $apiInstance->preNotification($body, $version, $trans_id, $transaction_src);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling DefaultApi->preNotification: ', $e->getMessage(), PHP_EOL;
}

// Configure OAuth2 access token for authorization: oauth2
$config = UPS\PreNotification\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$apiInstance = new UPS\PreNotification\Request\DefaultApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \UPS\PreNotification\PreNotification\PRENOTIFICATIONRequestWrapper(); // \UPS\PreNotification\PreNotification\PRENOTIFICATIONRequestWrapper | Generate sample code for popular API requests by selecting an example below. To view a full sample request and response, first click "Authorize" and enter your application credentials, then populate the required parameters above and click "Try it out".
$deprecated_version = "deprecated_version_example"; // string | Version of API.  Valid values: - v1
$trans_id = "trans_id_example"; // string | An identifier unique to the request. Length 32
$transaction_src = "testing"; // string | An identifier of the client/source application that is making the request.Length 512

try {
    $result = $apiInstance->preNotification_0($body, $deprecated_version, $trans_id, $transaction_src);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling DefaultApi->preNotification_0: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://wwwcie.ups.com/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**preNotification**](docs/Api/DefaultApi.md#prenotification) | **POST** /dangerousgoods/{version}/prenotification | Pre-Notification
*DefaultApi* | [**preNotification_0**](docs/Api/DefaultApi.md#prenotification_0) | **POST** /dangerousgoods/{deprecatedVersion}/prenotification | Pre-Notification

## Documentation For Models

 - [CommonErrorResponse](docs/Model/CommonErrorResponse.md)
 - [ErrorMessage](docs/Model/ErrorMessage.md)
 - [ErrorResponse](docs/Model/ErrorResponse.md)
 - [PRENOTIFICATIONRequestWrapper](docs/Model/PRENOTIFICATIONRequestWrapper.md)
 - [PRENOTIFICATIONResponseWrapper](docs/Model/PRENOTIFICATIONResponseWrapper.md)
 - [PackageChemicalRecord](docs/Model/PackageChemicalRecord.md)
 - [PackagePackageWeight](docs/Model/PackagePackageWeight.md)
 - [PackageWeightUnitOfMeasurement](docs/Model/PackageWeightUnitOfMeasurement.md)
 - [PreNotificationRequest](docs/Model/PreNotificationRequest.md)
 - [PreNotificationRequestRequest](docs/Model/PreNotificationRequestRequest.md)
 - [PreNotificationRequestShipment](docs/Model/PreNotificationRequestShipment.md)
 - [PreNotificationResponse](docs/Model/PreNotificationResponse.md)
 - [PreNotificationResponseResponse](docs/Model/PreNotificationResponseResponse.md)
 - [RequestTransactionReference](docs/Model/RequestTransactionReference.md)
 - [ResponseAlert](docs/Model/ResponseAlert.md)
 - [ResponseResponseStatus](docs/Model/ResponseResponseStatus.md)
 - [ResponseTransactionReference](docs/Model/ResponseTransactionReference.md)
 - [ShipmentPackage](docs/Model/ShipmentPackage.md)
 - [ShipmentService](docs/Model/ShipmentService.md)
 - [ShipmentShipFromAddress](docs/Model/ShipmentShipFromAddress.md)
 - [ShipmentShipToAddress](docs/Model/ShipmentShipToAddress.md)

## Documentation For Authorization


## oauth2

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 


## Author



