# HazMatHazMatChemicalRecord

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**chemical_record_identifier** | **string** | Identifies the Chemcial Record.  Required if SubVersion is greater than or equal to 1701. | [optional] 
**class_division_number** | **string** | This is the hazard class associated to the specified commodity. Required if CommodityRegulatedLevelCode is &#x27;LQ&#x27; or &#x27;FR&#x27;  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**id_number** | **string** | This is the ID number (UN/NA/ID) for the specified commodity. Required if CommodityRegulatedLevelCode &#x3D; LR, LQ or FR and if the field applies to the material by regulation. UN/NA/ID Identification Number assigned to the specified regulated good. (Include the UN/NA/ID as part of the entry).  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**transportation_mode** | **string** | The method of transport by which a shipment is approved to move and the regulations associated with that method.  Only required when the CommodityRegulatedLevelCode is FR or LQ.Valid values: 01 - Highway02 - Ground03 - Passenger Aircraft04 - Cargo Aircraft Only  Applies only if SubVersion is greater than or equal to 1701. For multiple ChemicalRecords per package having different TransportationMode, TransportationMode of first ChemicalRecord would be considered for validating and rating the package. All TransportationMode except for &#x27;04&#x27; are general service offering. If any chemical record contains &#x27;04&#x27; as TransportationMode, ShipperNumber needs to be authorized to use &#x27;04&#x27; as TransportationMode. | 
**regulation_set** | **string** | The Regulatory set associated with every regulated shipment. It must be the same across the shipment. Valid values:   ADR -  For Europe to Europe Ground Movement CFR -  For HazMat regulated by US Dept. of Transportation within the U.S. or ground shipments to Canada, IATA -  For Worldwide Air movement TDG -  For Canada to Canada ground movement or Canada to U.S. standard movement  Applies only if SubVersion is greater than or equal to 1701. For multiple ChemicalRecords per package or multiple packages containing different RegulationSet, RegulationSet of first ChemicalRecord would be considered for validating and rating the entire shipment. | 
**emergency_phone** | **string** | 24 Hour Emergency Phone Number of the shipper. Valid values for this field are (0) through (9) with trailing blanks. For numbers within the U.S., the layout is &#x27;1&#x27;, area code, 7-digit number. For all other countries or territories the layout is country or territory code, area code, number.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**emergency_contact** | **string** | The emergency information, contact name and/or contact number, required to be communicated when a call is placed to the EmergencyPhoneNumber. The information is required if there is a value in the EmergencyPhoneNumber field above and the shipment is with a US50 or PR origin and/or destination and the RegulationSet is IATA.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**reportable_quantity** | **string** | Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. If reportable quantity is met, &#x27;RQ&#x27; should be entered.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**sub_risk_class** | **string** | Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. Secondary hazardous characteristics of a package. (There can be more than one – separate each with a comma).  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**packaging_group_type** | **string** | This is the packing group category associated to the specified commodity. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. Must be shown in Roman Numerals.Valid values are:I, II,III,blank.   Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**quantity** | **string** | Required if CommodityRegulatedLevelCode &#x3D; LQ or FR. The numerical value of the mass capacity of the regulated good.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**uom** | **string** | Required if CommodityRegulatedLevelCode &#x3D; LQ or FR. The unit of measure used for the mass capacity of the regulated good. For Example: ml, L, g, mg, kg, cylinder, pound, pint, quart, gallon, ounce etc.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**packaging_instruction_code** | **string** | The packing instructions related to the chemical record. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**proper_shipping_name** | **string** | The Proper Shipping Name assigned by ADR, CFR or IATA. Required if CommodityRegulatedLevelCode &#x3D; LR, LQ or FR.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**technical_name** | **string** | The technical name (when required) for the specified commodity. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**additional_description** | **string** | Additional remarks or special provision information. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation.  Additional information that may be required by regulation about a hazardous material, such as, \&quot;Limited Quantity\&quot;, DOT-SP numbers, EX numbers.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**packaging_type** | **string** | The package type code identifying the type of packaging used for the commodity. (Ex: Fiberboard Box). Required if CommodityRegulatedLevelCode &#x3D; LQ or FR.   Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**hazard_label_required** | **string** | Defines the type of label that is required on the package for the commodity. Not applicable if CommodityRegulatedLevelCode &#x3D; LR or EQ.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**packaging_type_quantity** | **string** | The number of pieces of the specific commodity. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR.Valid values are 1 to 999.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**commodity_regulated_level_code** | **string** | Indicates the type of commodity - Fully Regulated (FR), Limited Quantity (LQ), Excepted Quantity (EQ), Lightly Regulated (LR). Default value is FR.Valid values are LR, FR, LQ, EQ.   Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**transport_category** | **string** | Transport Category.Valid values are 0 to 4.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 
**tunnel_restriction_code** | **string** | Defines what is restricted to pass through a tunnel.  Applies only if SubVersion is greater than or equal to 1701. | [optional] 

[[Back to Model list]](../../README.md#documentation-for-models) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to README]](../../README.md)

