# PackageServiceOptionsHazMat

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**packaging_type_quantity** | **string** | The number of pieces of the specific commodity. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR.  Valid values are 1 to 999. | [optional] 
**record_identifier1** | **string** | Reserved for future use. | [optional] 
**record_identifier2** | **string** | Reserved for future use. | [optional] 
**record_identifier3** | **string** | Reserved for future use. | [optional] 
**sub_risk_class** | **string** | Recommended if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation.  Secondary hazardous characteristics of a package. (There can be more than one – separate each with a comma). | [optional] 
**a_dr_item_number** | **string** | The type of regulated good for an ADR package where ADR is for Europe to Europe ground movement. | [optional] 
**a_dr_packing_group_letter** | **string** | Required if the field applies to the material by regulation. Field input is Arabic numerals, output is Roman numerals. Will be shown in Roman Numerals.  Valid values: - \&quot;1\&quot; &#x3D; \&quot;I\&quot;, - \&quot;2\&quot; &#x3D; \&quot;II\&quot;, - \&quot;3\&quot; &#x3D; \&quot;III\&quot;, - and blank. | [optional] 
**technical_name** | **string** | The technical name (when required) for the specified commodity. Recommended if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. | [optional] 
**hazard_label_required** | **string** | Defines the type of label that is required on the package for the commodity.   Not applicable if CommodityRegulatedLevelCode &#x3D; LR or EQ. | [optional] 
**class_division_number** | **string** | This is the hazard class associated to the specified commodity.  Required if CommodityRegulatedLevelCode is &#x27;EQ&#x27;, &#x27;LQ&#x27; or &#x27;FR&#x27; | [optional] 
**reference_number** | **string** | Optional reference number. It will be displayed only on label. | [optional] 
**quantity** | **string** | Required if CommodityRegulatedLevelCode &#x3D; EQ, LQ or FR. The numerical value of the mass capacity of the regulated good.  Should be more than 0.0. Valid characters are 0-9 and \&quot;.\&quot; (Decimal point). Limit to 1 digit after the decimal. The maximum length of the field is 5 including \&quot;.\&quot; (Decimal point) and can hold up to 1 decimal place. | [optional] 
**uom** | **string** | Required if CommodityRegulatedLevelCode &#x3D; LQ, EQ or FR. The unit of measure used for the mass capacity of the regulated good.   For Example: ml, L, g, mg, kg, cylinder, pound, pint, quart, gallon, ounce etc. | [optional] 
**packaging_type** | **string** | The type of package used to contain the regulated good. (Ex: Fiberboard Box). Required if CommodityRegulatedLevelCode &#x3D; LQ or FR.   Ex. FIBERBOARD BOX, WOOD(EN) BOX, PLASTIC JERRICAN, METAL BOX, STEEL DRUM, OTHER, PLASTIC BOX, PLASTIC DRUM, STYROFOAM BOX, CYLINDERS, ENVIROTAINER, PLYWOOD BOX, ALUMINUM DRUM, ALUMINUM CYLINDERS, PLASTIC PAIL, PLYWOOD DRUM, FIBER DRUM, STEEL JERRICAN, ALUMINUM JERRICAN, STEEL BOX, CARTON, ALUMINUM BOX | [optional] 
**id_number** | **string** | This is the ID number (UN/NA/ID) for the specified commodity.  Required if CommodityRegulatedLevelCode &#x3D; LR, LQ or FR and if the field applies to the material by regulation.  UN/NA/ID Identification Number assigned to the specified regulated good. (Include the UN/NA/ID as part of the entry). | [optional] 
**proper_shipping_name** | **string** | The Proper Shipping Name assigned by ADR, CFR or IATA. Required if CommodityRegulatedLevelCode &#x3D; LR, LQ or FR. | 
**additional_description** | **string** | Additional remarks or special provision information. Recommended if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation.  Additional information that may be required by regulation about a hazardous material, such as, \&quot;Limited Quantity\&quot;, DOT-SP numbers, EX numbers. | [optional] 
**packaging_group_type** | **string** | This is the packing group category associated to the specified commodity. Recommended if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. Must be shown in Roman Numerals.   Valid values: I II III blank | [optional] 
**packaging_instruction_code** | **string** | The packing instructions related to the chemical record. Required if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. | [optional] 
**emergency_phone** | **string** | 24 Hour Emergency Phone Number of the shipper. Valid values for this field are (0) through (9) with trailing blanks. For numbers within the U.S., the layout is 1, area code, 7-digit number. For all other countries or territories the layout is country or territory code, area code, number.  The following are restricted in the phone number period \&quot;.\&quot;, dash \&quot;-\&quot;, plus sign \&quot;+\&quot; and conventional parentheses \&quot;(\&quot; and \&quot;)\&quot;, \&quot;EXT\&quot; or \&quot;OPT\&quot; | [optional] 
**emergency_contact** | **string** | The emergency information, contact name and/or contract number, required to be communicated when a call is placed to the EmergencyPhoneNumber. The information is required if there is a value in the EmergencyPhoneNumber field above and the shipment is with a US50 or PR origin and/or destination and the RegulationSet is IATA. | [optional] 
**reportable_quantity** | **string** | Recommended if CommodityRegulatedLevelCode &#x3D; LQ or FR and if the field applies to the material by regulation. If reportable quantity is met, &#x27;RQ&#x27; should be entered. | [optional] 
**regulation_set** | **string** | The Regulatory set associated with every regulated shipment. It must be same across the shipment.  Valid values:  ADR &#x3D; Europe to Europe Ground Movement  CFR &#x3D; HazMat regulated by US Dept. of Transportation within the U.S. or ground shipments to Canada  IATA&#x3D; Worldwide Air movement  TDG&#x3D; Canada to Canada ground movement or Canada to U.S. standard movement.  Valid values are ADR, CFR, IATA and TDG. For multiple Chemical Records per package or multiple packages containing different RegulationSet, RegulationSet of first Chemical Record would be considered for validating and rating the entire shipment. | 
**transportation_mode** | **string** | Not applicable for ADR regulation set. Required for any other regulation set. Declares that a package was prepared according to ground passenger aircraft or cargo aircraft only.  Valid values:  Highway&#x3D;Highway  Ground&#x3D;Ground  PAX&#x3D;Passenger Aircraft  Passenger Aircraft&#x3D;Passenger Aircraft  CAO&#x3D;Cargo Aircraft Only  Cargo Aircraft Only&#x3D;Cargo Aircraft Only  Valid entries include: Highway, Ground, PAX, Passenger Aircraft, CAO and Cargo Aircraft Only. | 
**commodity_regulated_level_code** | **string** | Indicates the type of commodity - Fully Regulated (FR), Limited Quantity (LQ), Excepted Quantity (EQ) or Lightly Regulated (LR).  Valid values are LR, FR, LQ and EQ. Required for subversion 1701 or greater. LR and EQ are validated if subversion is 1701 or greater. FR, LQ will be validated if subversion is 1807 or greater | [optional] 
**transport_category** | **string** | Transport Category.  Valid values are 0 to 4. | [optional] 
**tunnel_restriction_code** | **string** | Defines what is restricted to pass through a tunnel. | [optional] 
**chemical_record_identifier** | **string** | Identifies the Chemical Record.  Required if SubVersion is greater than or equal to 1701. | [optional] 
**local_technical_name** | **string** | Technical name in local language. | [optional] 
**local_proper_shipping_name** | **string** | Proper shipping name in local langauge. | [optional] 

[[Back to Model list]](../../README.md#documentation-for-models) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to README]](../../README.md)

