# ShipmentShipmentServiceOptions

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**saturday_delivery_indicator** | **string** | Saturday delivery indicator. The presence indicates Saturday delivery is requested and the absence indicates Saturday delivery is not requested.  This is an empty tag, any value inside is ignored. | [optional] 
**saturday_pickup_indicator** | **string** | Saturday pickup indicator. The presence indicates Saturday pickup is requested and the absence indicates Saturday pickup is not requested.  This is an empty tag, any value inside is ignored. | [optional] 
**cod** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsCOD**](ShipmentServiceOptionsCOD.md) |  | [optional] 
**access_point_cod** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsAccessPointCOD**](ShipmentServiceOptionsAccessPointCOD.md) |  | [optional] 
**deliver_to_addressee_only_indicator** | **string** | Presence/Absence Indicator. Any value inside is ignored. DeliverToAddresseeOnlyIndicator is shipper specified restriction that requires the addressee to be the one who takes final delivery of the \&quot;Hold For PickUp at UPS Access Point\&quot; package. Presence of indicator means shipper restriction will apply to the shipment.  Only valid for Shipment Indication type \&quot;01 - Hold For PickUp at UPS Access Point\&quot;. | [optional] 
**direct_delivery_only_indicator** | **string** | Presence/Absence Indicator. Any value inside is ignored. Direct Delivery Only (DDO) accessorial in a request would ensure that delivery is made only to the ship to address on the shipping label. This accessorial is not valid with Shipment Indication Type \&quot;01 - Hold For Pickup At UPS Access Point\&quot; and \&quot;02 - UPS Access Point™ Delivery\&quot;. | [optional] 
**notification** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsNotification[]**](ShipmentServiceOptionsNotification.md) |  | [optional] 
**label_delivery** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsLabelDelivery**](ShipmentServiceOptionsLabelDelivery.md) |  | [optional] 
**international_forms** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsInternationalForms**](ShipmentServiceOptionsInternationalForms.md) |  | [optional] 
**delivery_confirmation** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsDeliveryConfirmation**](ShipmentServiceOptionsDeliveryConfirmation.md) |  | [optional] 
**return_of_document_indicator** | **string** | The flag indicates the ReturnOfDocument accessorial has been requested.  Valid for Poland to Poland forward shipment only. | [optional] 
**import_control_indicator** | **string** | Indicates that the Shipment is an ImportControl shipment. | [optional] 
**label_method** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsLabelMethod**](ShipmentServiceOptionsLabelMethod.md) |  | [optional] 
**commercial_invoice_removal_indicator** | **string** | CommercialInvoiceRemovalIndicator allows a shipper to dictate UPS to remove the Commercial Invoice from the user&#x27;s shipment before the shipment is delivered to the ultimate consignee. | [optional] 
**up_scarbonneutral_indicator** | **string** | UPS carbon neutral indicator presence at shipment level is required to create carbon neutral Shipments. | [optional] 
**pre_alert_notification** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsPreAlertNotification[]**](ShipmentServiceOptionsPreAlertNotification.md) |  | [optional] 
**exchange_forward_indicator** | **string** | Exchange forward indicator presence at shipment level is required to create exchange forward Shipments.  In the label routing Instruction text will be defaulted to \&quot;EXCHANGE-LIKE ITEM ONLY\&quot;. | [optional] 
**hold_for_pickup_indicator** | **string** | Hold For Pickup indicator. The empty tag means indicator is present.  This accessorial is only valid for UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday Shipment. | [optional] 
**dropoff_at_ups_facility_indicator** | **string** | Drop off At UPS Facility indicator. The empty tag means indicator is present.  This accessorial is only valid for UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday Shipment. | [optional] 
**lift_gate_for_pick_up_indicator** | **string** | Lift Gate For Pick Up indicator. The empty tag means indicator is present.  Lift Gate for Pickup is not allowed with Drop Off At UPS Facility for a UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday shipment.   When both Hold for Pickup and Drop Off At Facility are selected, neither of the Lift Gate accessorial (Pick Up or Delivery) are allowed for a UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday shipment.   This accessorial is only valid for UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday Shipment. | [optional] 
**lift_gate_for_delivery_indicator** | **string** | Lift Gate For Delivery indicator. The empty tag means indicator is present.  Lift Gate for Delivery is not allowed with Hold For Pickup for a UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday shipment.   When both Hold for Pickup and Drop Off At UPS Facility are selected, neither of the Lift Gate accessorial (Pick Up or Delivery) are allowed for a UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday shipment.   This accessorial is only valid for UPS Worldwide Express Freight and UPS Worldwide Express Freight Midday Shipment. | [optional] 
**sdl_shipment_indicator** | **string** | The presence of the tag SDLShipmentIndicator indicates Shipment is SDL. SDLShipmentIndicator presence means EEI form/ EEI Filing option required. | [optional] 
**epra_release_code** | **string** | Package Release code allows the consignee or claimant to pick-up a package at a UPS Access Point™. The shipper must provide the Package Release Code to the consignee so that they can provide the code to the UPS Access Point personnel as another item for authentication before the package is released to them. Package Release Code is only valid with ShipmentIndicationType 01 - Hold for Pickup at UPS Access Point™.  The release code must be between length 4 and 6 and only contain numbers. | [optional] 
**restricted_articles** | [**\UPS\Shipping\Shipping\ShipmentServiceOptionsRestrictedArticles**](ShipmentServiceOptionsRestrictedArticles.md) |  | [optional] 
**inside_delivery** | **string** | Inside delivery accessory. Valid values: 01 - White Glove 02 - Room of Choice 03 - Installation Default is Room of Choice.  Shippers account needs to have a valid contract for Heavy Goods Service. | [optional] 
**item_disposal** | **string** | Presence/Absence indicator. True if present; false otherwise. Any value is ignored. If present, indicates that the customer would like items disposed.  Shippers account needs to have a valid contract for Heavy Goods Service. | [optional] 

[[Back to Model list]](../../README.md#documentation-for-models) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to README]](../../README.md)

